package projet.iut.jeu_de_la_vie.view;

import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.text.Editable;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import projet.iut.jeu_de_la_vie.R;
import projet.iut.jeu_de_la_vie.model.Manager;
import projet.iut.jeu_de_la_vie.model.cellule.Cellule;
import projet.iut.jeu_de_la_vie.view.fragment.FragmentPlateau;
import projet.iut.jeu_de_la_vie.view.fragment.MenuFragment;

public class LauncherActivity extends AppCompatActivity {

    private Manager manager;
    private Button start;

    @Override
    protected void onResume(){
        super.onResume();
    }


    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        manager = new Manager();
        setContentView(R.layout.jeu_de_la_vie);
        /*
        //très moche à enlever plus tard
        start = findViewById(R.id.startButton);
        start.setOnClickListener(this::startGame);
        /*
        //manager.lancerJeu();
        start.setOnClickListener(l -> {
            EditText colones = findViewById(R.id.nbColone);
            //manager.getActualiseurCellule().getArbitre().getPlateau().setColone(Integer.parseInt(colones.getText().toString()));
            EditText lignes = findViewById(R.id.nbLignes);
            //manager.getActualiseurCellule().getArbitre().getPlateau().setLigne(Integer.parseInt(lignes.getText().toString()));
            for (List<Cellule> list : manager.getActualiseurCellule().getArbitre().getPlateau().getGrille()) {
                for (Cellule cell :  list) {
                    Log.d("instances",cell.isAlive().toString());
                }
            }
            manager.lancerJeu();
            manager.update();
        });
        findViewById(R.id.test).setOnClickListener(y -> {
            manager.getActualiseurCellule().getArbitre().getPlateau().setColone(2);
            manager.getActualiseurCellule().getArbitre().getPlateau().setLigne(2);
            manager.getActualiseurCellule().getArbitre().getPlateau().getCell(1, 1).setAlive(true);
            //manager.getActualiseurCellule().getArbitre().getPlateau().getCell(0, 0).setAlive(true);
            manager.getActualiseurCellule().getArbitre().getPlateau().getCell(1, 0).setAlive(true);
            manager.getActualiseurCellule().getArbitre().getPlateau().getCell(0, 1).setAlive(true);
        });
        */
        if(manager.isJeuLance()) {

        }else {
            getSupportFragmentManager().beginTransaction().add(R.id.menuView,MenuFragment.class,null).commit();
        }
    }

    public void updateGame (){

    }

    @Override
    protected void onStart (){
        super.onStart();
        //FragmentPlateau fragment = new FragmentPlateau();
        //fragment.setPlateau(manager.getActualiseurCellule().getArbitre().getPlateau());
    }

    @Override
    protected void onStop() {

        super.onStop();
    }

    public Manager getManager() {
        return manager;
    }

    private void setCellsColor(int color){
        manager.setCellsColor(color);
    }

    public void setCellsRed(View view){
        int red = Color.RED;
        setCellsColor(red);
    }
    public void setCellsGreen(View view){
        int green = Color.GREEN;
        setCellsColor(green);
    }
    public void setCellsBlue(View view){
        int blue = Color.BLUE;
        setCellsColor(blue);
    }

    public void startGame(Bundle bundle){
        Log.d("d", "" + (manager.getNumberOfLines()));
        Log.d("d", "" + (manager.getNomberOfColumns()));
        Log.d("d", "" + Cellule.getLivingColor());
        getSupportFragmentManager().beginTransaction().replace(R.id.fragmentContainerViewId, FragmentPlateau.class,bundle).commit();
    }

    @Override
    protected void onSaveInstanceState(@NonNull Bundle outState) {
        super.onSaveInstanceState(outState);
        outState.putSerializable("manager",manager); //c'est bourrin mais magique
    }

    @Override
    protected void onRestoreInstanceState(@NonNull Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
        manager = (Manager) savedInstanceState.getSerializable("manager");
    }

}
